diff --git a/web/pgadmin/static/js/components/PgTable.jsx b/web/pgadmin/static/js/components/PgTable.jsx
index 1b5179ac0..d17538d76 100644
--- a/web/pgadmin/static/js/components/PgTable.jsx
+++ b/web/pgadmin/static/js/components/PgTable.jsx
@@ -8,13 +8,26 @@
 //////////////////////////////////////////////////////////////
 
 import React from 'react';
-import { useTable, useRowSelect, useSortBy, useResizeColumns, useFlexLayout, useGlobalFilter } from 'react-table';
-import { FixedSizeList } from 'react-window';
+import {
+  useTable,
+  useRowSelect,
+  useSortBy,
+  useResizeColumns,
+  useFlexLayout,
+  useGlobalFilter,
+  useExpanded,
+} from 'react-table';
+import { VariableSizeList } from 'react-window';
 import { makeStyles } from '@material-ui/core/styles';
 import clsx from 'clsx';
 import PropTypes from 'prop-types';
 import AutoSizer from 'react-virtualized-auto-sizer';
 import { Checkbox } from '@material-ui/core';
+import { InputText } from './FormComponents';
+import FormView from 'sources/SchemaView';
+import { Box } from '@material-ui/core';
+import { _ } from 'core-js';
+
 /* eslint-disable react/display-name */
 const useStyles = makeStyles((theme) => ({
   root: {
@@ -29,22 +42,68 @@ const useStyles = makeStyles((theme) => ({
     width: '100% !important',
   },
   fixedSizeList: {
-    // position: 'relative',
     direction: 'ltr',
     overflowX: 'hidden !important',
-    overflow: 'overlay !important'
+    overflow: 'overlay !important',
+  },
+  customHeader:{
+    marginTop: '12px',
+    marginLeft: '4px'
+  },
+  searchBox: {
+    marginBottom: '5px',
+    display: 'flex',
+    background: '#fff'
+  },
+  tableContentWidth: {
+    width: 'calc(100% - 3px)',
+    height: 'auto !important'
+  },
+  tableContent: {
+    height: 'auto',
+    maxHeight: '260px'
+
+  },
+  searchPadding: {
+    flex: 2.5
+  },
+  checkbox: {
+    minWidth: 10
+  },
+  searchInput: {
+    flex: 1,
+    marginTop: 8,
+    borderLeft: 'none',
+    paddingLeft: 5,
+    marginRight: 8,
+    marginBottom: 8,
+
   },
   table: {
-    flexGrow:1,
-    minHeight:0,
+    flexGrow: 1,
+    minHeight: 0,
     borderSpacing: 0,
     width: '100%',
     overflow: 'hidden',
     borderRadius: theme.shape.borderRadius,
   },
-  extraTable:{
-    backgroundColor: theme.palette.grey[400],
-    flexGrow:1,
+  pgTableHeadar: {
+    display: 'flex',
+    flexGrow: 1,
+    overflow: 'hidden !important',
+    height: '100% !important',
+    flexDirection: 'column'
+  },
+
+  expandedForm: {
+    borderTopWidth: theme.spacing(0.5),
+    borderBottemWidth: theme.spacing(0.5),
+    borderStyle: 'solid ',
+    borderColor: theme.palette.grey[400],
+    position: 'relative',
+    height: '100%',
+    visibility: 'visible',
+    maxHeight: '260px'
   },
 
   tableCell: {
@@ -54,15 +113,15 @@ const useStyles = makeStyles((theme) => ({
     ...theme.mixins.panelBorder.right,
     position: 'relative',
     overflow: 'hidden',
+    height: '35px',
     textOverflow: 'ellipsis',
     whiteSpace: 'nowrap',
     backgroundColor: theme.otherVars.tableBg,
     // ...theme.mixins.panelBorder.top,
     ...theme.mixins.panelBorder.left,
-
   },
   selectCell: {
-    textAlign: 'center'
+    textAlign: 'center',
   },
   tableCellHeader: {
     fontWeight: theme.typography.fontWeightBold,
@@ -93,13 +152,28 @@ const useStyles = makeStyles((theme) => ({
     paddingTop: '0.35em',
     height: 35,
     backgroundPosition: '1%',
-  }
-}),
-);
+  },
+}));
 
 export default function PgTable({ columns, data, isSelectRow, ...props }) {
   // Use the state and functions returned from useTable to build your UI
   const classes = useStyles();
+  const [searchVal, setSearchVal] = React.useState('');
+  const tableRef = React.useRef();
+  const rowHeights = React.useRef({});
+  const rowRef = React.useRef({});
+
+  function getRowHeight(index, size) {
+    return rowHeights.current[index] + size || 35;
+  }
+
+  const setRowHeight = React.useCallback((index, size) => {
+    if(tableRef.current) {
+      tableRef.current.resetAfterIndex(0);
+      rowHeights.current = { ...rowHeights.current, [index]: size };
+    }
+  }, []);
+
   const defaultColumn = React.useMemo(
     () => ({
       minWidth: 150,
@@ -119,7 +193,9 @@ export default function PgTable({ columns, data, isSelectRow, ...props }) {
         <>
           <Checkbox
             color="primary"
-            ref={resolvedRef} {...rest} />
+            ref={resolvedRef} {...rest}
+            className={classes.checkbox}
+          />
         </>
       );
     },
@@ -141,9 +217,9 @@ export default function PgTable({ columns, data, isSelectRow, ...props }) {
     rows,
     prepareRow,
     selectedFlatRows,
-    state: { selectedRowIds },
+    state: { selectedRowIds, expanded },
     setGlobalFilter,
-    setHiddenColumns
+    setHiddenColumns,
   } = useTable(
     {
       columns,
@@ -153,11 +229,12 @@ export default function PgTable({ columns, data, isSelectRow, ...props }) {
     },
     useGlobalFilter,
     useSortBy,
+    useExpanded,
     useRowSelect,
     useResizeColumns,
     useFlexLayout,
-    hooks => {
-      hooks.visibleColumns.push(CLOUMNS => {
+    (hooks) => {
+      hooks.visibleColumns.push((CLOUMNS) => {
         if (isSelectRow) {
           return [
             // Let's make a column for selection
@@ -195,6 +272,11 @@ export default function PgTable({ columns, data, isSelectRow, ...props }) {
     }
   );
 
+  React.useEffect(()=>{    
+    tableRef.current?.resetAfterIndex(0);
+  },[expanded]);
+
+
   React.useEffect(() => {
     setHiddenColumns(
       columns
@@ -222,28 +304,40 @@ export default function PgTable({ columns, data, isSelectRow, ...props }) {
   }, [selectedRowIds]);
 
   React.useEffect(() => {
-    setGlobalFilter(props.searchText || undefined);
-  }, [props.searchText]);
-
+    setGlobalFilter(searchVal || undefined);
+  }, [searchVal]);
 
   const RenderRow = React.useCallback(
     ({ index, style }) => {
       const row = rows[index];
       prepareRow(row);
       return (
-        <div
-          {...row.getRowProps({
-            style,
-          })}
-          className={classes.tr}
-        >
-          {row.cells.map((cell) => {
-            return (
-              <div key={cell.column.id} {...cell.getCellProps()} className={clsx(classes.tableCell, row.original.icon && row.original.icon[cell.column.id], row.original.icon[cell.column.id] && classes.cellIcon)} title={cell.value}>
-                {cell.render('Cell')}
-              </div>
-            );
-          })}
+        <div className={classes.tableContentWidth} style={style} key={row.id}>
+          <div
+            {...row.getRowProps()}
+            className={classes.tr}
+          >
+            {row.cells.map((cell) => {
+              return (
+                <div key={cell.column.id} {...cell.getCellProps()} className={clsx(classes.tableCell, row.original.icon && row.original.icon[cell.column.id], row.original.icon[cell.column.id] && classes.cellIcon)} title={cell.value}>
+                  {cell.render('Cell')}
+                </div>
+              );
+            })}
+          </div>
+          {!_.isUndefined(row) && row.isExpanded && (
+            <Box key={row.id} className={classes.expandedForm} ref={rowRef} style={{height: rowHeights.current[index]}}>
+              <FormView
+                getInitData={() => {
+                  /*This is intentional (SonarQube)*/
+                }}
+                viewHelperProps={{ mode: 'properties' }}
+                schema={props.schema}
+                showFooter={false}
+                onDataChange={() => { }}
+              />
+            </Box>
+          )}          
         </div>
       );
     },
@@ -251,70 +345,96 @@ export default function PgTable({ columns, data, isSelectRow, ...props }) {
   );
   // Render the UI for your table
   return (
-    <AutoSizer className={(props.type ==='panel' ? props.className: classes.autoResizer)}>
-      {({ height}) => (
-        <div {...getTableProps()} className={classes.table}>
-          <div>
-            {headerGroups.map((headerGroup) => (
-              <div key={''} {...headerGroup.getHeaderGroupProps()}>
-                {headerGroup.headers.map((column) => (
-                  <div
-                    key={column.id}
-                    {...column.getHeaderProps()}
-                    className={clsx(
-                      classes.tableCellHeader,
-                      column.className
-                    )}
-                  >
+    <Box className={classes.pgTableHeadar}>
+      <Box className={classes.searchBox}>
+        {props.customHeader && (<Box className={classes.customHeader}> <props.customHeader /></Box>)}
+        <Box className={classes.searchPadding}></Box>
+        <InputText
+          placeholder={'Search'}
+          className={classes.searchInput}
+          value={searchVal}
+          onChange={(val) => {
+            setSearchVal(val);
+          }}
+        />
+      </Box>
+      
+      <AutoSizer
+        className={props.type === 'panel' ? props.className : classes.autoResizer}
+      >
+        {({ height }) => (
+          <div {...getTableProps()} className={classes.table}>
+            <div>
+              {headerGroups.map((headerGroup) => (
+                <div key={''} {...headerGroup.getHeaderGroupProps()}>
+                  {headerGroup.headers.map((column) => (
                     <div
-                      {...(column.sortble
-                        ? column.getSortByToggleProps()
-                        : {})}
+                      key={column.id}
+                      {...column.getHeaderProps()}
+                      className={clsx(classes.tableCellHeader, column.className)}
                     >
-                      {column.render('Header')}
-                      <span>
-                        {column.isSorted
-                          ? column.isSortedDesc
-                            ? ' 🔽'
-                            : ' 🔼'
-                          : ''}
-                      </span>
-                      {column.resizable && (
-                        <div
-                          {...column.getResizerProps()}
-                          className={classes.resizer}
-                        />
-                      )}
+                      <div
+                        {...(column.sortble ? column.getSortByToggleProps() : {})}
+                      >
+                        {column.render('Header')}
+                        <span>
+                          {column.isSorted
+                            ? column.isSortedDesc
+                              ? ' 🔽'
+                              : ' 🔼'
+                            : ''}
+                        </span>
+                        {column.resizable && (
+                          <div
+                            {...column.getResizerProps()}
+                            className={classes.resizer}
+                          />
+                        )}
+                      </div>
                     </div>
-                  </div>
-                ))}
-                {/* <span className={classes.extraTable}></span> */}
-              </div>
-            ))}
-          </div>
+                  ))}
+                </div>
+              ))}
+            </div>
+
+            <div {...getTableBodyProps()} >
+              <VariableSizeList
+                ref={tableRef}
+                className={classes.fixedSizeList}
+                height={height}
+                itemCount={rows.length}
 
-          <div {...getTableBodyProps()} className={classes}>
-            <FixedSizeList
-              className={classes.fixedSizeList}
-              height={height - 75}
-              itemCount={rows.length}
-              itemSize={35} 
-              sorted={props?.sortOptions}
-            >
-              {RenderRow}
-            </FixedSizeList>
+                itemSize={(i) => {
+                  if (_.isUndefined(rows[i].isExpanded)) {
+                    rows[i].isExpanded = false;
+                  }
+                  if (rowRef.current && rows[i].isExpanded) {
+                    setRowHeight(i, rowRef.current.offsetHeight);
+                  }
+                  return rows[i].isExpanded ? getRowHeight(i, 35): 35;
+                }}
+                sorted={props?.sortOptions}
+              >
+                {RenderRow}
+                
+              </VariableSizeList>
+            </div>
           </div>
-        </div>
-      )}
-    </AutoSizer>
+        )}
+      </AutoSizer>
+    </Box>
   );
 }
 
 PgTable.propTypes = {
   stepId: PropTypes.number,
   height: PropTypes.number,
+  customHeader: PropTypes.func,
   className: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
-  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
+  children: PropTypes.oneOfType([
+    PropTypes.arrayOf(PropTypes.node),
+    PropTypes.node,
+  ]),
   getToggleAllRowsSelectedProps: PropTypes.func,
   columns: PropTypes.array,
   data: PropTypes.array,
@@ -324,8 +444,6 @@ PgTable.propTypes = {
   getSelectedRows: PropTypes.func,
   searchText: PropTypes.string,
   type: PropTypes.string,
-  sortOptions:  PropTypes.array,
-
+  sortOptions: PropTypes.array,
+  schema: PropTypes.object
 };
-
-
diff --git a/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx b/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx
index a0f38ea2f..015c3939d 100644
--- a/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx
+++ b/web/pgadmin/tools/grant_wizard/static/js/GrantWizard.jsx
@@ -17,7 +17,7 @@ import Wizard from '../../../../static/js/helpers/wizard/Wizard';
 import WizardStep from '../../../../static/js/helpers/wizard/WizardStep';
 import PgTable from 'sources/components/PgTable';
 import { getNodePrivilegeRoleSchema } from '../../../../../pgadmin/browser/server_groups/servers/static/js/privilege.ui.js';
-import { InputSQL, InputText, FormFooterMessage, MESSAGE_TYPE } from '../../../../static/js/components/FormComponents';
+import { InputSQL, FormFooterMessage, MESSAGE_TYPE } from '../../../../static/js/components/FormComponents';
 import getApiInstance from '../../../../static/js/api_instance';
 import SchemaView from '../../../../static/js/SchemaView';
 import clsx from 'clsx';
@@ -117,7 +117,6 @@ export default function GrantWizard({ sid, did, nodeInfo, nodeData }) {
   const [selectedObject, setSelectedObject] = React.useState([]);
   const [selectedAcl, setSelectedAcl] = React.useState({});
   const [msqlData, setSQL] = React.useState('');
-  const [searchVal, setSearchVal] = React.useState('');
   const [loaderText, setLoaderText] = React.useState('');
   const [tablebData, setTableData] = React.useState([]);
   const [privOptions, setPrivOptions] = React.useState({});
@@ -314,17 +313,6 @@ export default function GrantWizard({ sid, did, nodeInfo, nodeData }) {
       loaderText={loaderText}
     >
       <WizardStep stepId={0}>
-        <Box className={classes.searchBox}>
-          <Box className={classes.searchPadding}></Box>
-          <InputText
-            placeholder={'Search'}
-            className={classes.searchInput}
-            value={searchVal}
-            onChange={(val) => {
-              setSearchVal(val);}
-            }>
-          </InputText>
-        </Box>
         <Box className={classes.panelContent}>
           <PgTable
             className={classes.table}
@@ -332,7 +320,6 @@ export default function GrantWizard({ sid, did, nodeInfo, nodeData }) {
             columns={columns}
             data={tablebData}
             isSelectRow={true}
-            searchText={searchVal}
             getSelectedRows={getTableSelectedRows}>
           </PgTable>
         </Box>
diff --git a/web/webpack.config.js b/web/webpack.config.js
index 3f9c5f8f4..ed9ad4472 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -469,10 +469,8 @@ module.exports = [{
         options: {
           type: 'commonjs',
           imports: [
-            'pure|pgadmin.dashboard',
             'pure|pgadmin.browser.quick_search',
             'pure|pgadmin.tools.user_management',
-            'pure|pgadmin.browser.object_sql',
             'pure|pgadmin.browser.bgprocess',
             'pure|pgadmin.node.server_group',
             'pure|pgadmin.node.server',
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index a2e8f28e7..f9af1531f 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -208,14 +208,13 @@ var webpackShimConfig = {
     'pgadmin.browser.dialog': path.join(__dirname, './pgadmin/browser/static/js/dialog'),
     'pgadmin.browser.node': path.join(__dirname, './pgadmin/browser/static/js/node'),
     'pgadmin.browser.node.ui': path.join(__dirname, './pgadmin/browser/static/js/node.ui'),
-    'pgadmin.browser.object_sql': path.join(__dirname, './pgadmin/misc/sql/static/js/sql'),
     'pgadmin.browser.panel': path.join(__dirname, './pgadmin/browser/static/js/panel'),
     'pgadmin.browser.toolbar': path.join(__dirname, './pgadmin/browser/static/js/toolbar'),
     'pgadmin.browser.server.privilege': path.join(__dirname, './pgadmin/browser/server_groups/servers/static/js/privilege'),
     'pgadmin.browser.server.variable': path.join(__dirname, './pgadmin/browser/server_groups/servers/static/js/variable'),
     'pgadmin.browser.utils': '/browser/js/utils',
     'pgadmin.browser.wizard': path.join(__dirname, './pgadmin/browser/static/js/wizard'),
-    'pgadmin.dashboard': path.join(__dirname, './pgadmin/dashboard/static/js/dashboard'),
+    'pgadmin.dashboard': path.join(__dirname, './pgadmin/dashboard/static/js/Dashboard'),
     'pgadmin.datagrid': path.join(__dirname, './pgadmin/tools/datagrid/static/js/datagrid'),
     'pgadmin.file_manager': path.join(__dirname, './pgadmin/misc/file_manager/static/js/file_manager'),
     'pgadmin.file_utility': path.join(__dirname, './pgadmin/misc/file_manager/static/js/utility'),
